unit moduuli;
(*
   Kerhon jsenrekisterin datamoduuli keskitetty tietokannan hallintaa varten.
   MN, 12.4.2004.
*)
interface

uses
  SysUtils, Classes, DB, ADODB;

type
  TKerhoData = class(TDataModule)
    Connection: TADOConnection;
    Jasenet: TADOTable;
    Harrastukset: TADOTable;
    Kaupungit: TADOTable;
    JasenetDS: TDataSource;
    Jasenetjasen_id: TAutoIncField;
    Jasenetetunimi: TWideStringField;
    Jasenetsukunimi: TWideStringField;
    Jasenetosoite: TWideStringField;
    Jasenetpuhelin: TWideStringField;
    Jasenetjasenmaksu: TIntegerField;
    Jasenetliittymisvuosi: TIntegerField;
    Jasenetmaksu_maksettu: TBooleanField;
    Harrastuksetharrastus_id: TAutoIncField;
    Harrastuksetnimi: TWideStringField;
    Kaupungitkaupunki_id: TAutoIncField;
    Kaupungitnimi: TWideStringField;
    LiitosDS: TDataSource;
    Jasenetkaupunki_id: TIntegerField;
    Jasenetkaupunki: TStringField;
    Liitos: TADOTable;
    Liitosjasen_id: TIntegerField;
    Liitosharrastus_id: TIntegerField;
    Liitosharrastus: TStringField;
    HarrastuksetDS: TDataSource;
    procedure DataModuleCreate(Sender: TObject);
  private
    function FormAccessConnectionString(dbname:String):string;
    procedure ActivateDataSets(d:array of TDataSet);
  public
  end;

var
  KerhoData: TKerhoData;

implementation

{$R *.dfm}

procedure TKerhoData.ActivateDataSets(d: array of TDataSet);
var i:integer;
begin
  for i:=Low(d) to High(d) do d[i].Active:=true;
end;

procedure TKerhoData.DataModuleCreate(Sender: TObject);
begin
  Connection.ConnectionString:=FormAccessConnectionString('jasenrekisteri.mdb');
  Connection.Connected:=true;
  ActivateDataSets([Jasenet,Harrastukset,Kaupungit,Liitos]);
end;


// Luo ADO:n connectionStringin EXE-hakemistossa olevaan access-tietokantaan (ei tarvita absoluuttista polkua!)
function TKerhoData.FormAccessConnectionString(dbname: string):string;
begin
  Result:='Provider=Microsoft.Jet.OLEDB.4.0;Data Source='+ExtractFileDir(ParamStr(0))+'\'+dbname+';Persist Security Info=False';
end;

end.
